/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005-2012 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: memory.h 599 2012-02-05 06:40:30Z ertl-hiro $
 */

/*
 *		ꥪ֥ȴ⥸塼
 */

#ifndef TOPPERS_MEMORY_H
#define TOPPERS_MEMORY_H

/*
 *  °ʥͥѤ
 *
 *  HRP2ͥǼºݤ˻ȤƤΤϡTOPPERS_USTACKΤߤǤ롥
 *  ¾2ĤϡͥǤ϶̤ưɬפʤ
 *
 *  ե졼դĹסΰϡ¾Υ
 *  ֥Ȥ礵礬뤿ᡤTOPPERS_ATTSECΥ°
 *  Ȥ롥
 */
#define TOPPERS_ATTSEC	0x0100	/* ATT_SECATA_SECޤATT_MODATA_MOD
								   Ͽ줿ꥪ֥ */
#define TOPPERS_ATTMEM	0x0200	/* ATT_MEMATA_MEMϿ줿ꥪ
								    */
#define TOPPERS_USTACK	0x0400	/* Υ桼åΰ */

#ifndef TOPPERS_MACRO_ONLY
#ifndef OMIT_STANDARD_MEMINIB

/*
 *  ꥪ֥Ƚ֥å
 *
 *  ̤ΰTA_NULLˤФƤϡ٤ƤΥĥѥ
 *  acptn1acptn2acptn4ˤ0ˤ롥ޤ꡼ɥ꡼TA_RO
 *  ΰФƤϡ̾1ʽߥˤΥĥѥ
 *  acptn1ˤ0ˤ롥
 */
typedef struct memory_initialization_block {
	ATR		mematr;			/* ꥪ֥° */
	ACPTN	acptn4;			/* Υĥѥ */
	ACPTN	acptn1;			/* ̾1Υĥѥ󡿥TCB */
	ACPTN	acptn2;			/* ̾2Υĥѥ */
} MEMINIB;

/*
 *  ե졼ꥪ֥Ƚ֥å
 *
 *  ꥪ֥Ƚ֥åΥȥꥪ֥Ȥ
 *  ƬϤΰ衤ꥪ֥Ƚ֥åΰϡ⡤
 *  ե졼kernel_cfg.cΰȤ롥
 */

/*
 *  ꥪ֥Ƚ֥åΥȥkernel_cfg.c
 */
extern const uint_t		tnum_meminib;

/*
 *  ꥪ֥ȤƬϤΰkernel_cfg.c
 */
extern void *const		memtop_table[];

/*
 *  ꥪ֥Ƚ֥åΰkernel_cfg.c
 */
extern const MEMINIB	meminib_table[];

#endif /* OMIT_STANDARD_MEMINIB */

/*
 *  ꥪ֥ȴ⥸塼ν
 */
extern void		initialize_memory(void);

/*
 *  ꥪ֥Ƚ֥åθ
 *
 *  ꥪ֥Ƚ֥å顤addrޤꥪ֥
 *  򸡺Υǥå֤
 */
#ifndef OMIT_STANDARD_MEMINIB

extern int_t	search_meminib(const void *addr);

#endif /* OMIT_STANDARD_MEMINIB */

/*
 *  ΰ褬ꥪ֥Ȥ˴ޤޤƤ뤫Υå
 *
 *  ƬϤbaseǥsizeΥΰ褬ƬϤmobaseǥ
 *  mosizeΥꥪ֥Ȥ˴ޤޤƤtrueǤʤ
 *  false֤
 */
Inline bool_t
within_memobj(const void *base, SIZE size, void *mobase, SIZE mosize)
{
	return((SIZE)(mobase) <= (SIZE)(base) && size <= mosize
			&& (SIZE)((char *)(base) - (char *)(mobase)) <= mosize - size);
}

/*
 *  ΰ褬桼åΰ˴ޤޤƤ뤫Υå
 *
 *  ƬϤbaseǥsizeΥΰ褬p_tcbǻꤵ륿
 *  Υ桼åΰ˴ޤޤƤtrueǤʤ
 *  false֤
 */
#ifndef USE_TSKINICTXB

Inline bool_t
within_ustack(const void *base, SIZE size, TCB *p_tcb)
{
	return(within_memobj(base, size,
					p_tcb->p_tinib->ustk, p_tcb->p_tinib->ustksz));
}

#else /* USE_TSKINICTXB */

extern bool_t	within_ustack(const void *base, SIZE size, TCB *p_tcb);

#endif /* USE_TSKINICTXB */

/*
 *  ؤν߸Υå
 *
 *  ¹ݸɥᥤʥ桼ɥᥤˤꤷΰؤν
 *  ߸äƤ뤫å߸äƤtrue
 *  Ǥʤfalse֤¹ݸɥᥤ󤬥ͥɥᥤ
 *  λϡδؿƤǤϤʤʤ
 */
extern bool_t	probe_mem_write(const void *base, SIZE size);

/*
 *  ꤫ɽФΥå
 *
 *  ¹ݸɥᥤʥ桼ɥᥤˤꤷΰؤ
 *  ФäƤ뤫åɽФäƤtrue
 *  Ǥʤfalse֤¹ݸɥᥤ󤬥ͥɥᥤ
 *  λϡδؿƤǤϤʤʤ
 */
extern bool_t	probe_mem_read(const void *base, SIZE size);

/*
 *  åΰ˴ޤޤƤ뤫Υå
 *
 *  ꤷΰ褬Υåΰ˴ޤޤƤ뤫ɤ
 *  åޤޤƤtrueǤʤfalse֤
 */
extern bool_t	probe_stack(const void *base, SIZE size);

/*
 *  ꥢΥåΤΥޥ
 *
 *  ʲϡ饤Ȥñ̤2ζҾǤ뤳ȤꤷƤ롥
 */
#ifndef PROBE_MEM_WRITE
#define PROBE_MEM_WRITE(p_var, type) \
				(ALIGN_TYPE(p_var, type) && (rundom == TACP_KERNEL \
					|| probe_mem_write((void *)(p_var), sizeof(*(p_var)))))
#endif /* PROBE_MEM_WRITE */

#ifndef PROBE_MEM_READ
#define PROBE_MEM_READ(p_var, type) \
				(ALIGN_TYPE(p_var, type) && (rundom == TACP_KERNEL \
					|| probe_mem_read((void *)(p_var), sizeof(*(p_var)))))
#endif /* PROBE_MEM_READ */

/*
 *  åؤΥåΤΥޥ
 */
#ifndef PROBE_STACK
#define PROBE_STACK(sp, size) \
				(ALIGN_TYPE(sp, STK_T) && probe_stack(sp, size))
#endif /* PROBE_STACK */

#endif /* TOPPERS_MACRO_ONLY */

/*
 *  data֥å
 */
typedef struct {
	void	*start_data;		/* dataƬ */
	void	*end_data;			/* dataνλ */
	void	*start_idata;		/* ǡΰƬ */
} DATASECINIB;

/*
 *  dataοȽ֥åΥꥢkernel_cfg.c
 */
extern const uint_t	tnum_datasec;
extern const DATASECINIB	datasecinib_table[];

/*
 *  bss֥å
 */
typedef struct {
	void	*start_bss;			/* bssƬ */
	void	*end_bss;			/* bssνλ */
} BSSSECINIB;

/*
 *  bssοȽ֥åΥꥢkernel_cfg.c
 */
extern const uint_t	tnum_bsssec;
extern const BSSSECINIB	bsssecinib_table[];

#endif /* TOPPERS_MEMORY_H */
